{-# OPTIONS --cubical #-}

open import Agda.Primitive.Cubical
open import Cubical.Foundations.Equiv
open import Cubical.Foundations.Prelude
open import Data.Bool
open import Data.Fin

--------------------------------------------------------------------------------

ap : {A B : Type} (f : A → B) {x y : A} → x ≡ y → f x ≡ f y
ap f p i = f (p i)

--------------------------------------------------------------------------------

data Other : Type where
  Top : Other
  Bottom : Other

convert : Bool → Other
convert true = Top
convert false = Bottom

convert-inv : Other → Bool
convert-inv Top = true
convert-inv Bottom = false

convert-inv-id : (b : Bool) → convert-inv (convert b) ≡ b
convert-inv-id true = refl
convert-inv-id false = refl

convert-fiber : (y : Other) → fiber convert y
convert-fiber Top = true , refl
convert-fiber Bottom = false , refl

convert-fiber-is-contr : (y : Other) → (fz : fiber convert y) → convert-fiber y ≡ fz
convert-fiber-is-contr y fz =
  let
    fx : fiber convert y
    fx = convert-fiber y

    x : Bool
    x = fst fx

    z : Bool
    z = fst fz

    eqv : convert z ≡ y
    eqv = snd fz

    eqv2 : convert x ≡ y
    eqv2 = snd fx

    eqv3 : y ≡ convert x
    eqv3 = sym eqv2

    eqv4 : convert z ≡ convert x
    eqv4 = eqv ∙ eqv3

    -- This is the `ap g p`
    eqv5 : convert-inv (convert z) ≡ convert-inv (convert x)
    eqv5 = ap convert-inv eqv4

    eqv6 : z ≡ x
    eqv6 = sym (convert-inv-id z) ∙ eqv5 ∙ convert-inv-id x

    eqv7 : x ≡ z
    eqv7 = sym eqv6

    -- y ≡ convert x
    sfx = snd fx
    sfz = snd fz

    what : sfx ≡ ? -- sfz
    what = ?
  in

  -- z = fst fz
  -- convert-fiber y ≡ fz
  -- fx ≡ fz
  -- Look into this more:
    -- (x , convert x₁ ≡ y) ≡ (z , convert z₁ ≡ y)
    -- Σ[ x ∈ A ] (convert x ≡ y)
    -- (x , _)
  --  - x ≡ z
  --  ------ - (convert x₁ ≡ y) ≡ (convert z₁ ≡ y)
  --
  -- eqv7 ?
  ?

convert-is-equiv : isEquiv convert
convert-is-equiv .equiv-proof y = convert-fiber y , convert-fiber-is-contr y

convert-equiv : Bool ≃ Other
convert-equiv = convert , convert-is-equiv
