module ApPractice where

import Relation.Binary.PropositionalEquality as Eq
open import Agda.Primitive using (Level; lzero; lsuc; _⊔_) renaming (Set to Type) public
open import Relation.Binary
open import Relation.Binary.Indexed.Heterogeneous
open import Relation.Binary.Core public
open import Relation.Binary.Definitions public
open import Relation.Binary.Structures public
open import Relation.Binary.Bundles public
open import Relation.Binary.PropositionalEquality.Core public
open import Relation.Binary.PropositionalEquality.Properties public
open import Relation.Binary.PropositionalEquality.Algebra public

_∙_ = trans
_∘_ : {A B C : Set} → (A → B) → (B → C) → A → C
(f ∘ g) x = g (f x)

ap : {A B : Set}
  → (f : A → B)
  → {x y : A}
  → (p : x ≡ y)
  → f x ≡ f y
ap f {x} {x} refl = refl

lemma222_i : {A B C : Set}
  → (f : A → B)
  → (g : B → C)
  → {x y z : A}
  → (p : x ≡ y)
  → (q : y ≡ z)
  → ap f (p ∙ q) ≡ ap f p ∙ ap f q
lemma222_i f g refl refl = refl

lemma222_ii : {A B C : Set}
  → (f : A → B)
  → {x y : A}
  → (p : x ≡ y)
  → ap f (sym p) ≡ sym (ap f p)
lemma222_ii f refl = refl

lemma222_iii : {A B C : Set}
  → (f : A → B)
  → (g : B → C)
  → {x y z : A}
  → (p : x ≡ y)
  → (q : y ≡ z)
  → ap g (ap f p) ≡ ap (f ∘ g) p
lemma222_iii f g refl refl = refl

id : {ℓ : Level} → {A : Set ℓ} → A → A
id x = x

lemma222_iv : {A : Set}
  → {x y : A}
  → (p : x ≡ y)
  → ap id p ≡ p
lemma222_iv p = refl
