{-# OPTIONS --cubical #-}

module Ch6 where

open import Cubical.Core.Everything
open import Cubical.Data.Equality
open import Cubical.Foundations.Prelude
open import Cubical.HITs.S1

-- private
--   variable
--     ℓ ℓ' : Level
--     A : Type ℓ
-- 
-- transport′ : ∀ (C : A → Type ℓ') {x y : A} → x ≡ y → C x → C y                
-- transport′ C refl b = b                                                       
-- 
-- apd : {C : A → Type ℓ} (f : (x : A) → C x) {x y : A} (p : x ≡ y) → transport′ C p (f x) ≡ f y              
-- apd f refl = refl

-- apd : {A : Set} {B : A → Set} (f : (x : A) → B x) {x y : A} (p : x ≡ y)
--  → transport p (f x ≡ f y)
  -- → PathP (λ i → B (p i)) (f x) (f y)
-- apd f p i = f (p i)
-- apd f p = \i . f (p i)

-- Lemma 6.2.5, if A is a type together with a : A and p : a = a, then there is
-- a function f : 𝕊¹ → A with f(base) :≡ a and ap\_f(loop) := p

lemma625 : {A : Type} → (a : A) → (p : a ≡ a) → (S¹ → A)
lemma625 a p base = a
lemma625 a p (loop i) = p i

lemma625prop1 : {A : Type} {a : A} {p : a ≡ a} → (lemma625 a p base ≡ a)
lemma625prop1 = refl

ap : {A B : Set} (f : A → B) {x y : A} → x ≡ y → f x ≡ f y
ap f p i = f (p i)

lemma625prop2 : {A : Type} (a : A) → (p : a ≡ a) → ap (lemma625 a p) loop ≡ p
lemma625prop2 a p = refl

-- Lemma 2.3.2 (Path lifting)

-- Lemma 6.2.8
 
-- a : (A : Type) → (f : S¹ → A) → apd f loop
apd : {A : Type} {P : A → Type} (f : (x : A) → P x) {x y : A} (p : x ≡ y)
  → PathP (λ i → P (p i)) (f x) (f y)
apd f p i = f (p i)

lemma628 : {A : Type} (f g : S¹ → A)
  → (p : f base ≡ g base)
  → (q : PathP (λ i → p i ≡ p i) (ap f loop) (ap g loop))
  → (x : S¹)
  → f x ≡ g x
lemma628 f g p q base = p
lemma628 f g p q (loop i) = ?
-- f (loop i) = g (loop i)
-- when i = i0
--   f base = g base
--   _ j0 = f base
--   _ j1 = g base
-- when i = i1
--   f base = g base
--   _ j0 = f base
--   _ j1 = g base
-- lemma628 f g p q (loop i) j = p j

-- Lemma 6.2.9

-- lemma629f : {A : Type} → (g : S¹ → A) → {x : A} → Σ A (x ≡ x)
-- 
-- lemma629 : {A : Type} → (S¹ → A) ≡ ((x : A) → x ≡ x)
-- lemma629 = ?

-- Lemma 6.3.1
-- Type I is contractible

record is-contr {ℓ} (A : Type ℓ) : Type ℓ where
  constructor contr
  field
    centre : A
    paths : (x : A) → centre ≡ x
open is-contr public

-- Lemma 6.3.2
-- Function extensionality

lemma632 : {A B : Type} {f g : A → B} → ((x : A) → f x ≡ g x) → f ≡ g
lemma632 {A} {B} {f} {g} p =
  -- For all x : A, define a function pₓ : I → B
  ?
  where
    pₓ : {x : A} → I → B
    -- pₓ {x} i0 = f x
    -- pₓ {x} i1 = g x
--       pₓ i0 = f x
--       pₓ i1 = g x
--       pₓ seg = p x in
--   let q : I → (A → B)
--       q i x = pₓ i in

-- Lemma 6.4.1

open import Data.Bool
open import Data.Unit
open import Data.Empty using (⊥; ⊥-elim)

¬_ : Set → Set
¬ A = A → ⊥

_≢_ : ∀ {A : Set} → A → A → Set
x ≢ y  =  ¬ (x ≡ y)

Bool-size : Bool → Type
Bool-size true = ⊤
Bool-size false = ⊥

true≢false : true ≢ false
true≢false p = let x = subst Bool-size p tt in ?

-- lemma641 : loop ≢ refl
-- lemma641 p = true≢false 

-- Lemma 6.4.5

open import Cubical.Data.Sigma

lemma645 : (A : Set)
  → (P : A → Set)
  → (x y : A)
  → (p q : x ≡ y)
  → (r : p ≡ q)
  → (u : P x)
  → ⊤
-- lemma645 A P x y p q r u =
--   let x = transport {A = p} r ? in
--   ?
