{-# OPTIONS --without-K #-}

module CircleThing2 where

open import Agda.Primitive renaming (Set to Type)

open import elementary-number-theory.integers
open import elementary-number-theory.natural-numbers
open import foundation-core.identity-types
open import foundation.univalence
open import synthetic-homotopy-theory.circle

infix 10 _≡_
_≡_ = _＝_

loops-to-ℤ : base-𝕊¹ ≡ base-𝕊¹ → ℤ
loops-to-ℤ p = ?

ℤ-to-loops : ℤ → base-𝕊¹ ≡ base-𝕊¹
ℤ-to-loops = ind-ℤ
    (λ _ → base-𝕊¹ ≡ base-𝕊¹)
    (inv loop-𝕊¹)
    neg-ver
    refl
    (loop-𝕊¹)
    pos-ver
  where
    pos-ver : ℕ → base-𝕊¹ ≡ base-𝕊¹ → base-𝕊¹ ≡ base-𝕊¹
    pos-ver zero-ℕ p = refl
    pos-ver (succ-ℕ n) p = loop-𝕊¹ ∙ pos-ver n p

    neg-ver : ℕ → base-𝕊¹ ≡ base-𝕊¹ → base-𝕊¹ ≡ base-𝕊¹
    neg-ver zero-ℕ p = refl
    neg-ver (succ-ℕ n) p = (inv loop-𝕊¹) ∙ neg-ver n p
