```
{-# OPTIONS --cubical #-}
module CubicalHott.Chapter2 where
open import Cubical.Core.Everything
```

# 2.1 Types are higher groupoids

```
lemma-2-1-2 : {A : Set}
  → {x y z : A}
  → x ≡ y
  → y ≡ z
  → x ≡ z
lemma-2-1-2 {A} {x} p q i = hcomp (λ j → λ { (i = i0) → x ; (i = i1) → q j }) (p i)

_∙_ = lemma-2-1-2
```

# 2.2 Functions are functors

```
lemma-2-2-1 : {A B : Set} {x y : A}
  → (f : A → B)
  → x ≡ y
  → f x ≡ f y
lemma-2-2-1 f p i = f (p i)

ap = lemma-2-2-1
```

# 2.4 Homotopies and equivalences

```
definition-2-4-1 : {A : Set} {P : A → Set}
  → (f g : (x : A) → P x)
  → Set
definition-2-4-1 {A} f g = (x : A) → f x ≡ g x

_∼_ = definition-2-4-1

lemma-2-4-2-1 : {A : Set} {P : A → Set}
  → (f : (x : A) → P x)
  → f ∼ f
lemma-2-4-2-1 f x i = f x

lemma-2-4-2-2 : {A : Set} {P : A → Set}
  → (f g : (x : A) → P x)
  → (f∼g : f ∼ g)
  → g ∼ f
lemma-2-4-2-2 f g f∼g x i = f∼g x (~ i)

lemma-2-4-2-3 : {A : Set} {P : A → Set}
  → (f g h : (x : A) → P x)
  → (f∼g : f ∼ g)
  → (g∼h : g ∼ h)
  → f ∼ h
lemma-2-4-2-3 {A} f g h f∼g g∼h x = (f∼g x) ∙ (g∼h x)
-- TODO: Wtf how does this work?

lemma-2-4-3 : {A B : Set}
  → (f g : A → B)
  → (H : f ∼ g)
  → {x y : A}
  → (p : x ≡ y)
  → (H x ∙ ap g p) ≡ (ap f p ∙ H y)
lemma-2-4-3 f g H {x} {y} p i =
  {!   !}
```
