```
module HottBook.Chapter6 where

open import HottBook.Chapter1
open import HottBook.Chapter2
```

# 6 Higher inductive types

### Definition 6.2.2 (Dependent paths)

```
dep-path : {A : Set} 
  → (P : A → Set) 
  → {x y : A} 
  → (p : x ≡ y)
  → (u : P x) → (v : P y) → Set
dep-path P p u v = transport P p u ≡ v
```

Circle definition

```
postulate
  S¹ : Set
  base : S¹
  loop : base ≡ base
  S¹-elim : (P : S¹ → Set)
    → (p-base : P base)
    → (p-loop : dep-path P loop p-base p-base)
    → (x : S¹) → P x
```

### Lemma 6.2.5

```
lemma6∙2∙5 : {A : Set}
  → (a : A)
  → (p : a ≡ a)
  → S¹ → A
lemma6∙2∙5 {A} a p circ = S¹-elim P p-base p-loop circ
  where
    P : S¹ → Set
    P _ = A

    p-base = a

    p-loop : transport P loop a ≡ a
    p-loop =
      let wtf = lemma2∙3∙8 loop in
      {!   !}
```

## 6.3 The interval

```
postulate
  I : Set
  0I : I
  1I : I
  seg : 0I ≡ 1I
```

## 6.10 Quotients

```
-- module Quotient (A : Set) (R : A × A → Prop) where
--   postulate
--     _/_ : Set → Set → Set
--     q : (A : Set) → A / A
```