```
module HottBook.Chapter9 where

open import Agda.Primitive
open import HottBook.Chapter1
```

## 9.1 Categories and precategories

```
record precat {l : Level} (A : Set l) : Set (lsuc l) where
  field
    hom : (a b : A) → Set
    id : (a : A) → hom a a
    comp : {a b c : A} → hom a b → hom b c → hom a c
    lol : (a b : A) → (f : hom a b) → (f ≡ comp f (id b)) × (f ≡ comp (id a) f)

```

### Definition 9.1.2

```
record isIso {l : Level} {A : Set l} {PC : precat A} {a b : A} (f : precat.hom PC a b) : Set (lsuc l) where
  field
    g : precat.hom PC b a
    g-f : precat.comp f g ≡ precat.id a
```

### Lemma 9.1.4

```
idtoiso : {A : Set}
  → (PC : precat A)
  → (a b : A)
  → a ≡ b
  → precat.hom PC a b
```